INSTALL(1)

NAME
install - copy files and set attributes

SYNOPSIS
install [options] [-s] [--strip] source dest
install [options] [-s] [--strip] source... directory
install [options] [-d,--directory] directory...

Options (shortest form):
[-b] [-c] [-D] [-g group] [-m mode] [-o owner] [-S SUFFIX] [-V {numbered,existing,simple}] [--help] [--version] [--]

DESCRIPTION
install copies files while setting their permission modes and, if possible, their owner and group.

In the first of these invocation forms, the source file is copied to the dest target file. In the second, each of the source files are copied to the destination directory. In the last, each directory (and any missing parent directories) is created.

install is similar to cp, but allows you to control the attributes of destination files. It is typically used in Makefiles to copy programs into their destination directories. It refuses to copy files onto themselves.

OPTIONS

-c  Ignored; for compatibility with old Unix versions of install.

-d, --directory
    Create each given directory and any missing parent directories, setting the owner, group and mode as given on the command line or to the defaults. It also gives any parent directories it creates those attributes. (This is different from the SunOS 4.x install, which gives directories that it creates the default attributes.)

-D  Create all leading components of the dest except the last, then copy source to dest. This option is useful in the first format in the synopsis, above. (New in fileutils-4.0.)

-g group, --group=group
    Set the group ownership of installed files or directories to group. The default is the process's current group. group may be either a group name or a numeric group ID.

-m mode, --mode=mode
    Set the permissions for the installed file or directory to mode, which can be either an octal number, or a symbolic mode as in chmod, with 0 as the point of departure. The default mode is 0755 — read, write, and execute for the owner, and read and execute for group and other.

-o owner, --owner=owner
    If install has appropriate privileges (is run as root), set the ownership of installed files or directories to owner. The default is `root'. owner may be either a user name or a numeric user ID.

-s, --strip
    Strip the symbol tables from installed binary executables.

GNU BACKUP OPTIONS
The GNU versions of programs like cp, mv, ln, install and patch will make a backup of files about to be overwritten, changed or destroyed if that is desired. That backup files are desired is indicated by the -b option. How they should be named is specified by the -V option. In case the name of the backup file is given by the name of the file extended by a suffix, this suffix is specified by the -S option.

-b, --backup
    Make backups of files that are about to be overwritten or removed.

-S SUFFIX, --suffix=SUFFIX
    Append SUFFIX to each backup file made. If this option is not specified, the value of the SIMPLE_BACKUP_SUFFIX environment variable is used. And if SIMPLE_BACKUP_SUFFIX is not set, the default is `~'.

-V METHOD, --version-control=METHOD
    Specify how backup files are named. The METHOD argument can be `numbered' (or `t'), `existing' (or `nil'), or `never' (or `simple'). If this option is not specified, the value of the VERSION_CONTROL environment variable is used. And if VERSION_CONTROL is not set, the default backup type is `existing'.

    This option corresponds to the Emacs variable `version-control'. The valid METHODs are (unique abbreviations are accepted):

    t, numbered
        Always make numbered backups.

    nil, existing
        Make numbered backups of files that already have them, simple backups of the others.

    never, simple
        Always make simple backups.

GNU STANDARD OPTIONS

--help
    Print a usage message on standard output and exit successfully.

--version
    Print version information on standard output, then exit successfully.

--  Terminate option list.

ENVIRONMENT
The variables LANG, LC_ALL, LC_CTYPE and LC_MESSAGES have the usual meaning. For the GNU version, the variables SIMPLE_BACKUP_SUFFIX and VERSION_CONTROL control backup file naming, as described above.

CONFORMING TO
4.2BSD (which had the -c, -m, -o, -g and -s options).

NOTES
This page describes install as found in the fileutils-4.0 package; other versions may differ slightly.